
#include "keycode.h"


#define __readonly code


#define NULL 0

#define PREFIX_E0 0x100


extern void pc_put(unsigned char c);
#define output(C) pc_put(C)
//extern void output(unsigned char c);


__readonly unsigned short encodetable[] = {
	// 0x00
	0x00,
	0x0e,
	0x16,
	0x1e,
	0x26,
	0x25,
	0x2e,
	0x36,
	0x3d,
	0x3e,
	0x46,
	0x45,
	0x4e,
	0x55,
	0x6a,
	0x66,

	// 0x10
	0x0d,
	0x15,
	0x1d,
	0x24,
	0x2d,
	0x2c,
	0x35,
	0x3c,
	0x43,
	0x44,
	0x4d,
	0x54,
	0x5b,
	0x5d,
	0x58,
	0x1c,

	// 0x20
	0x1b,
	0x23,
	0x2b,
	0x34,
	0x33,
	0x3b,
	0x42,
	0x4b,
	0x4c,
	0x52,
	0x5d,
	0x5a,
	0x12,
	0x61,
	0x1a,
	0x22,

	// 0x30
	0x21,
	0x2a,
	0x32,
	0x31,
	0x3a,
	0x41,
	0x49,
	0x4a,
	0x51,
	0x59,
	0x14,
	0x00,
	0x11,
	0x29,
	0x11 | PREFIX_E0,
	0x00,

	// 0x40
	0x14 | PREFIX_E0,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x70 | PREFIX_E0,
	0x71 | PREFIX_E0,
	0x00,
	0x00,
	0x6b | PREFIX_E0,

	// 0x50
	0x6c | PREFIX_E0,
	0x69 | PREFIX_E0,
	0x00,
	0x75 | PREFIX_E0,
	0x72 | PREFIX_E0,
	0x7d | PREFIX_E0,
	0x7a | PREFIX_E0,
	0x00,
	0x00,
	0x74 | PREFIX_E0,
	0x77,
	0x6c,
	0x6b,
	0x69,
	0x00,
	0x4a | PREFIX_E0,

	// 0x60
	0x75,
	0x73,
	0x72,
	0x70,
	0x7c,
	0x7d,
	0x74,
	0x7a,
	0x71,
	0x7b,
	0x79,
	0x00,
	0x5a | PREFIX_E0,
	0x00,
	0x76,
	0x00,

	// 0x70
	0x05,
	0x06,
	0x04,
	0x0c,
	0x03,
	0x0b,
	0x83,
	0x0a,
	0x01,
	0x09,
	0x78,
	0x07,
	0x00,
	0x7e,
	0x00,
	0x00,
	
	// 0x80
	0x00,
	0x00,
	0x00,
	0x67,
	0x64,
	0x13,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
};


__readonly unsigned char _make124_default[] =
	"\xe0\x12\xe0\x7c";
__readonly unsigned char _make124_shift_ctrl[] =
	"\xe0\x7c";
__readonly unsigned char _make124_alt[] =
	"\x84";
__readonly unsigned char _break124_default[] =
	"\xe0\xf0\x7c\xe0\xf0\x12";
__readonly unsigned char _break124_shift_ctrl[] =
	"\xe0\xf0\x7c";
__readonly unsigned char _break124_alt[] =
	"\xf0\x84";
__readonly unsigned char _make126_default[] =
	"\xe1\x14\x77\xe1\xf0\x14\xf0\x77";
__readonly unsigned char _make126_ctrl[] =
	"\xe0\x7e\xe0\xf0\x7e";

__readonly unsigned char _e0_f0_12[] = "\xe0\xf0\x12";
__readonly unsigned char _e0_12[] = "\xe0\x12";

void outputs(unsigned char *p)
{
	while (*p) output(*p++);
}

void EncodeKeyCode(unsigned char number, unsigned short keyflag)
{
	if (number == 124) {
		if (keyflag & KEYFLAG_MAKE) {
			if (keyflag & (KEYFLAG_SHIFT | KEYFLAG_CTRL)) {
				outputs(_make124_shift_ctrl);
			} else if (keyflag & KEYFLAG_ALT) {
				outputs(_make124_alt);
			} else {
				outputs(_make124_default);
			}
		} else {
			if (keyflag & (KEYFLAG_SHIFT | KEYFLAG_CTRL)) {
				outputs(_break124_shift_ctrl);
			} else if (keyflag & KEYFLAG_ALT) {
				outputs(_break124_alt);
			} else {
				outputs(_break124_default);
			}
		}
	} else if (number == 126) {
		if (keyflag & KEYFLAG_MAKE) {
			if (keyflag & KEYFLAG_CTRL) {
				outputs(_make126_ctrl);
			} else {
				outputs(_make126_default);
			}
		}
	} else {
		unsigned short keycode = 0;
		if (keyflag & KEYFLAG_FN) {
			switch (number) {
			case 2: number = 112; break;
			case 3: number = 113; break;
			case 4: number = 114; break;
			case 5: number = 115; break;
			case 6: number = 116; break;
			case 7: number = 117; break;
			case 8: number = 118; break;
			case 9: number = 119; break;
			case 10: number = 120; break;
			case 11: number = 121; break;
			case 12: number = 122; break;
			case 14: number = 123; break;
			case 15: number = 125; break;
			case 30: number = 90; break;
			case 55: number = 56; break;
			case 61: number = 110; break;
			case 76: number = 75; break;
			case 79: number = 80; break;
			case 83: number = 85; break;
			case 84: number = 86; break;
			case 89: number = 81; break;
			case 253: number = 124; break;
			case 254: number = 126; break;
			}
		} else if (keyflag & KEYFLAG_NUMLOCK) {
			switch (number) {
			case 37: number = 93; break;
			case 38: number = 98; break;
			case 39: number = 103; break;
			case 23: number = 92; break;
			case 24: number = 97; break;
			case 25: number = 102; break;
			case 8: number = 91; break;
			case 9: number = 96; break;
			case 10: number = 101; break;
			case 55: number = 106; break;
			case 40: number = 105; break;
			case 26: number = 100; break;
			case 11: number = 95; break;
			case 52: number = 99; break;
			case 27: number = 108; break;
			}
		}
		if (number < 0x90) keycode = encodetable[number];
		if (keycode) {
			if (number >= 75 && number <= 89) {
				if (keyflag & KEYFLAG_MAKE) {
					if (keyflag & KEYFLAG_SHIFT) {
						outputs(_e0_f0_12);
					} else if (keyflag & KEYFLAG_NUMLOCK) {
						outputs(_e0_12);
					}
				}
			}

			if (keycode & PREFIX_E0) output(0xe0);
			if (!(keyflag & KEYFLAG_MAKE)) output(0xf0);
			output(keycode);

			if (number >= 75 && number <= 89) {
				if (!(keyflag & KEYFLAG_MAKE)) {
					if (keyflag & KEYFLAG_SHIFT) {
						outputs(_e0_12);
					} else if (keyflag & KEYFLAG_NUMLOCK) {
						outputs(_e0_f0_12);
					}
				}
			}
		}
	}
}




__readonly unsigned char decodetable[] = {
	  2,  3,  4, 46,  5,  6,  7,  8,131, 17, 18, 19, 20, 21, 22, 13,
	 47, 31, 32, 33, 34, 35, 36, 61, 30, 16, 58,  0,  0,  0,  0,  0,
	  0,  0,255, 60,  0,  0,  0,  0,  0,  0,  0,  0, 48, 49, 50, 51,
	 12, 14, 15,124,  9, 10, 11,132, 27, 28, 42,126, 23, 24, 25, 26,
	 41, 43,133,  0, 37, 38, 39, 40, 55, 83,  1,  0, 52, 53, 54,255,
	 76, 79, 84, 89,  0,  0,  0,  0, 44, 57,  0,  0,  0,  0,  0,  0,
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
};


unsigned short DecodeKeyCode(unsigned char c)
{
	unsigned short keycode = decodetable[c & 0x7f];
	if (c & 0x80) keycode |= 0x8000;
	return keycode;
}


