

	.module uart0


	.globl _uart0_interrupt_handler
	.globl _uart0_initialize
	.globl _uart0_get
	.globl _uart0_put

.globl _uart0_rx_queue


_SCON0	=	0x0098
_SBUF0	=	0x0099
_RI0	=	0x0098
_TI0	=	0x0099
_ES0	=	0x00ac


	.area DSEG    (DATA)


_txbusy:
	.ds 1
_uart0_tx_queue:
	.ds 10
_uart0_rx_queue:
	.ds 10


	.area CSEG    (CODE)


	ar0 = 0x00
	ar1 = 0x01
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07


_uart0_interrupt_handler:
	push	psw
	push	acc
	push	b
	push	dpl
	push	dph
	mov	psw,#0x00

00110$:
	jnb  _TI0,00107$

	clr	_TI0
	mov	_txbusy,#0
	mov	dpl,#_uart0_tx_queue
	lcall qget
	jc 00110$		; empty

	mov	_SBUF0,1
	mov	_txbusy,#1
	sjmp 00110$

00107$:
	jnb  _RI0,00112$

	clr	_RI0
	mov	a,_SBUF0
	mov	dpl,#_uart0_rx_queue
	lcall qput
	sjmp 00110$

00112$:
	pop	dph
	pop	dpl
	pop	b
	pop	acc
	pop	psw
	reti


_uart0_get:
	clr	_ES0
	mov	dpl,#_uart0_rx_queue
	lcall qget
	mov dptr,#0xffff
	jc _uart0_get_0

	mov dpl,a
	mov dph,#0
_uart0_get_0:
	setb _ES0
	ret

_uart0_put:
	clr	_ES0

	mov	a,dpl
	mov	dpl,#_uart0_tx_queue
	lcall qput
	mov	a,_txbusy
	jnz _uart0_put_0

	lcall qget
	jc _uart0_put_0

	mov	_SBUF0,a
	mov	_txbusy,#1
	clr	_TI0

_uart0_put_0:
	setb _ES0
	ret

_uart0_initialize:
	push ar0

	mov r0,#_uart0_tx_queue
	mov @r0,#0
	inc r0
	mov @r0,#0

	mov r0,#_uart0_rx_queue
	mov @r0,#0
	inc r0
	mov @r0,#0

	mov	_txbusy,#0

	mov	_SCON0,#0x50
	clr	_RI0
	clr	_TI0
	setb _ES0

	pop ar0
	ret



